;Adobe Helvetica normal
;-------------------------------------------------
;Berechnet den nchsten Punkt einer Linie
;-------------------------------------------------
;The result is the next point of a line
;-------------------------------------------------
;	Code for the best assembler: The Netwide Assembler: NASM
;	Copyright (C) 2004 by Sebastian Beck; sebastian.bw@freenet.de

;	Wenn Sie eine Spende machen wollen, fragen Sie mich ber E-Mail
;	nach meiner Bankverbindung.

;	If you want to make a donation, please question me by e-mail for
;	my banking connection.

;-------------------------------------------------
;%include "./INC/LINIE.inc"
;%include "./INC/linie.inc"
;%include "./INC/outnc-2.7.inc"
;%include "./INC/brechner.inc"

;buf			resb	25
;Deltax		dd	0		;Schritte X
;Deltay		dd	0		;Schritte Y
;Deltaz		dd	0		;Schritte Z
;Linex			dd	0		;Aktueller X-Wert der Linie
;Liney			dd	0		;Aktueller Y-Wert der Linie
;Linez			dd	0		;Aktueller Z-Wert der Linie

;Linedev		db	0		;Liniendefiniton
;Bit	2 1 0				X		Y		Z
;	0 0 0		nach		links+	vorne+	oben+
;	0 0 1		nach		rechts-	vorne+	oben+
;	0 1 0		nach		links+	hinten-	oben+
;	0 1 1		nach		rechts-	hinten-	oben+
;	1 0 0		nach		links+	vorne+	unten-
;	1 0 1		nach		rechts-	vorne+	unten-
;	1 1 0		nach		links+	hinten-	unten-
;	1 1 1		nach		rechts-	hinten-	unten-
;-------------------------------------------------

LINIE:
section .text

	mov	eax,3
	mov	ebx,[datnum]
	mov	ecx,buf
	mov	edx,14
	int	80h
	cmp	eax,14
	jz	.a
	call	error1
	jmp	Ende
.a:
	mov	dword[Linex],0
	mov	dword[Liney],0
	mov	dword[Linez],0
	mov	al,[buf]
	mov	[Linedev],al
	mov	eax,[buf+1]
	mov	[Deltax],eax
	mov	edx,eax			;b edx soll das lngste Ma enthalten
	mov	ebx,Linex			;b und in ebx den zugehrigen Zeiger
	mov	ebp,Deltax			;b und in ebp den vergleichs Zeiger
	
	mov	eax,[buf+5]
	mov	[Deltay],eax
	cmp	edx,eax
	jae	.a5
	mov	edx,eax			;b speichere in edx das grere Ma
	mov	ebx,Liney			;b und in ebx den zugehrigen Zeiger
	mov	ebp,Deltay			;b und in ebp den vergleichs Zeiger
.a5:
	mov	eax,[buf+9]
	mov	[Deltaz],eax
	cmp	edx,eax
	jae	.b
	mov	edx,eax			;b speichere in edx das grere Ma
	mov	ebx,Linez			;b und in ebx den zugehrigen Zeiger
	mov	ebp,Deltaz			;b und in ebp den vergleichs Zeiger
.b:
	mov	ecx,0				;b ecx wird in brechner gesetzt
	mov	byte[statusB],cl		;b statusB zurcksetzen
.c:
	call	brechner			;b setzt Delay
	call	linie
	call	outnc
	mov	eax,[ebx]			;b Ende berechnen eax = Line_
	mov	cl,[statusB]			;b neue Stufe in ecx
	add	eax,ecx			;b zum addieren
	cmp	eax,[ebp]			;b kann bis Ende gebremst werden ebp = Lnge
	jnz	.c5				;b
	or	byte[statusB],10000000b	;b remsen
.c5:						;b
	mov	eax,[Deltax]
	cmp	eax,[Linex]
	jnz	.c
	mov	eax,[Deltay]
	cmp	eax,[Liney]
	jnz	.c
	mov	eax,[Deltaz]
	cmp	eax,[Linez]
	jnz	.c
	
	mov	al,[buf+13]
	ret


